class PagesController < ApplicationController
  
  include ApplicationHelper

  before_filter :get_item, :only => [:index_from_link, :show_from_link]
  
  def index
    @item = Page.find_by_name('home')
    if @item
      impressionist(@item)
      render_page
    else
      render :text => 'You need a home page'
    end
  end
  
  def show  
    #begin  
      @item = Item.first(:conditions => {:path => params[:page_name]})
      if @item && @item.is_published && (@item.enabled_for.nil? ? true : @item.enabled_for.include?(I18n.locale.to_s))
        impressionist(@item)
        case @item._type
          when 'Page'    
            render_page
          when 'Link'
            redirect_to @item[:url]
        end
      else
        render :file => "#{Rails.root}/public/404.html", :status => :not_found
      end
     #rescue
     #  render :file => "#{Rails.root}/public/404.html", :status => :not_found
     #end
   end
   
   def index_from_link
      url = "/#{@item.path}"
      options = ''
      options << "?page_main=#{params[:page_main]}" unless params[:page_main].blank?
      options << "#{options.blank? ? '?' : '&'}category_id=#{params[:category_id]}" unless params[:category_id].blank?
      options << "#{options.blank? ? '?' : '&'}tag_id=#{params[:tag_id]}" unless params[:tag_id].blank?
      redirect_to url + options
   end
   
   def show_from_link
      url = "/#{@item.path}?id=#{params[:id]}"
      options = ''
      options << "&preview=#{params[:preview]}" unless params[:preview].blank?
      redirect_to url + options
   end
   
   def load_orbit_bar
     render :partial => 'layouts/orbit_bar', :locals => {:referer => request.referer}
   end
   
   protected
   
   def get_item
      module_app = ModuleApp.first(:conditions => {:key => params[:app_name]})
      @item = Item.first(:conditions => {:module_app_id => module_app.id, :app_frontend_url => params[:app_action]})
   end
  
end
